package com.yc.ship.module.product.dal.mysql.productBase;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.framework.mybatis.core.mapper.BaseMapperX;
import com.yc.ship.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.yc.ship.module.product.controller.admin.productBase.vo.ProductBasePageReqVO;
import com.yc.ship.module.product.controller.admin.productBase.vo.ProductBaseRespVO;
import com.yc.ship.module.product.controller.admin.productBase.vo.ShipRespVO;
import com.yc.ship.module.product.dal.dataobject.productBase.ProductBaseDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * 基础产品 Mapper
 *
 * @author 管理员
 */
@Mapper
public interface ProductBaseMapper extends BaseMapperX<ProductBaseDO> {

    default PageResult<ProductBaseDO> selectPage(ProductBasePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ProductBaseDO>()
                .likeIfPresent(ProductBaseDO::getName, reqVO.getName())
                .eqIfPresent(ProductBaseDO::getProjectId, reqVO.getProjectId())
                .orderByDesc(ProductBaseDO::getId));
    }

    IPage<ProductBaseRespVO> queryProductBasePage(IPage<ProductBaseRespVO> page, @Param("reqVO") ProductBasePageReqVO pageReqVO);

    IPage<ProductBaseRespVO> selectProductBasePage(IPage<ProductBaseRespVO> page, @Param("reqVO") ProductBasePageReqVO pageReqVO);
    List<ShipRespVO> selectShipList();

}
